package ch.ethz.inf.vs.android.nethz.tutorial;

import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.view.Menu;
import android.widget.ProgressBar;
import android.widget.TextView;

public class WorkerActivity extends Activity {


	class MyWorker extends AsyncTask<Integer, Integer, Void> {
	
		private int index;
		private final ProgressBar progress;
		private final TextView textview;

		public MyWorker(final ProgressBar bar,
	        	         final TextView text) {
			this.progress = bar;
			this.textview = text;
		}

		@Override
		protected void onPreExecute() {
			progress.setMax(100);
			progress.setProgress(0);
		}

		@Override
		protected Void doInBackground(Integer... step) {
			for (int i=0; i<100/step[0]; ++i) {
				try {
					Thread.sleep(500);
					index += step[0];
				} catch (InterruptedException e) { }
				publishProgress(step);
			}
			return null;
		}

	    @Override
	    protected void onProgressUpdate(final Integer... values) {
	        textview.setText(""+index);
	        progress.incrementProgressBy(values[0]);
	    }

	    @Override
	    protected void onPostExecute(final Void result) {
	        textview.setText(R.string.btn_sound);
	    }
	}

	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_worker);
        
        final ProgressBar progress = (ProgressBar)findViewById(R.id.progress_bar);
        final TextView    textview = (TextView)findViewById(R.id.txt_progress);

        new MyWorker(progress, textview).execute(20);

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.worker, menu);
		return false;
	}

}
